_G[gTable] = {};

local aTmpVal     = gTable;
local aInfoShown  = false;
local aCount      = 0;
cm.SetupTable(_G[aTmpVal]);

-- Called on Init
_G[gTable].OnInit = function(pObj)

   pObj.mState= 0;
	aCount     = 0;
	aInfoShown = false;

	pObj.mCsData:SetVal("aInfoShown", aInfoShown);

end

-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)
	aInfoShown = pObj.mCsData:GetBool("aInfoShown");
	aCount = 0;
end

-- Called after a level is loaded
_G[gTable].OnLevelLoad = function(pObj)
   pObj.mGobj.mSoundPlayer:PlayMusic("IcMusicOutsides2");
  	pObj.mGobj.mSoundPlayer:PlayAmbient("Ambient_FairyGarden", 5);
  	aInfoShown = pObj.mCsData:GetBool("aInfoShown");
end

-- Called after a level is exited
_G[gTable].OnLevelExit = function(pObj)
   pObj.mGobj.mSoundPlayer:ClearMusic(0);
   pObj.mGobj.mSoundPlayer:FadeoutLoopingSfx(20);
   pObj.mGobj.mSoundPlayer:FadeoutAmbient(20);
end


-- Called on a update
_G[gTable].OnUpdate = function(pObj)

	if not aInfoShown then
		aCount = aCount + 1;
		if aCount == 25 then
			aInfoShown = true;
			pObj.mCsData:SetVal("aInfoShown", aInfoShown);
			--pObj.mPdata:ShowCurLevelInfo();
			pObj.mPdata:ShowCurLevelInfo("PH_SFX_INGAME_11");
		end
	end

	if pObj.mState == 0 then
      if cm.GetGlobalBoolIndirect(pObj, "ActivatorFlag1")
         and cm.GetGlobalBoolIndirect(pObj, "ActivatorFlag2") then
         cm.SetGlobalValIndirect(pObj, "SetFlag1", true);
         pObj.mState = pObj.mState + 1;
         IcPlaySample("PH_SFX_PRESSUREPLATEDOWN");
      end
   end
	
end

-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)


	if pName == "" then

   	if pPolyNum == 0 then
         cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
      elseif pPolyNum == 1 then
         cm.GetShowInfo(pObj, "InfoStr2", "InfoTime2");
      elseif pPolyNum == 2 then
         cm.GetShowInfo(pObj, "InfoStr3", "InfoTime3");
      elseif pPolyNum == 3 then
         cm.GetShowInfo(pObj, "InfoStr4", "InfoTime4");
      elseif pPolyNum == 4 then
         cm.GetShowInfo(pObj, "InfoStr5", "InfoTime5");
      end
      return true;

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

end

-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aImg = IcImageWrap(pObj.mSmallImage);
	assert(aImg);

	aRect = aImg:GetCelRect(pObj.mCurCell);
	pG:DrawImage(aImg:GetImage(), pObj.mSmPos.x, pObj.mSmPos.y, aRect);

end

-- Returns the sparkle info
_G[gTable].GetParticleSystemInfo = function(pObj, pPolyNum, pName)
   local aParticleSystemTable	= {};
   aParticleSystemTable[0]		= true;
   aParticleSystemTable[1]		= "PH_PSYS_UNDYING_SPARKLE_BG";
   return aParticleSystemTable;
end

